#include <iostream.h>
#define TRUE 1
#define FALSE 0
#define Node 20 //    .
typedef int Boolean;
typedef struct L *Lref; // :    .
typedef struct T *Tref; // :    .

//   .
typedef struct L 
{ 
  int Key; //  .
  int Count; // .
  Boolean Flag; //    .
  Tref Trail; //   .
  Lref Next; //       .
};

//   .
typedef struct T 
{ 
  Lref Id; 
  Tref Next; 
};

class Spisok
{
  private:
    Lref Head; //     .
    Lref Tail; //    
               //     .
    int  X[Node+1];
    void SearchGraph (int, Lref *);
  public:
    Spisok() {//   .
              Head = Tail =  new (L); }
    Lref GetHead() { return Head; }
    Lref GetTail() { return Tail; }
    void MakeGraph ();
    void PrintGraph ();
    void Summa (int, int, int);
    void X1 (Lref t) {X[1] = t->Key;};
};

void main ()
{
  Spisok A;
  Lref t; //    
          //    .
  Lref t1;  
  int n=0,B;
  //      .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  // n -    Head.
  t = A.GetHead();
  while (t!=A.GetTail())
    { n++; t = (*t).Next; }
  // ------------------------------------ 
  //  .
  cout << "  B: "; cin >> B;
  t = A.GetHead();
  while (t!=A.GetTail())
  {
    //.
    t1 = A.GetHead();
    while (t1!=A.GetTail())
    { t1->Flag = TRUE; t1 = t1->Next; }
      A.X1(t); t->Flag = FALSE;
      A.Summa (2,B,n);
      t = t->Next;
  }
} 

void Spisok::SearchGraph (int w, Lref *h)
//      
//  w  ,      Head. 
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     Head.
  { Tail = new (L); (**h).Count = 0; 
    (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head   
//,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
     cout<<"   : "; cin>>y;
     //,      (x,y)?
     SearchGraph (x, &p); SearchGraph (y,&q);
     r = (*p).Trail; Res = FALSE; 
     while ((r!=NULL)&&(!Res)) 
       if ((*r).Id==q) Res = TRUE; 
       else r = (*r).Next; 
     if (!Res) //  ,     .
      { t = new (T); (*t).Id = q; 
        (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; } 
     cout<<"   : "; cin>>x;
  }
}

void Spisok::PrintGraph ()
//  ,   
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
     cout<< (*p).Key << "("; q = (*p).Trail; 
     while (q!=NULL) 
      { cout<<(*(*q).Id).Key; q = (*q).Next; } 
     cout<<")"; p = (*p).Next; cout<<" ";
  }
}

void Spisok::Summa (int k, int B, int n)
//    , 
//    Head.
{
  int i;  // .
  Lref t; //  k-   .
  Tref r;
  int S;
  int Set1[256]; // .
  int m; //   Set1.

  SearchGraph (X[k-1], &t);
  r = t->Trail;
  while ( r != NULL )
  {
    X[k] = r->Id->Key;
    //   Set1 
    //,     X .
    for (int j=0;j<256;Set1[j++]=0);
    for (i=1;i<=k;i++) Set1[X[i]]=1;
    // m -     Set1.
    m = 0;
    for(i=1;i<=Node;i++)
     if (Set1[i]==1) m++;
    // ------------------------------- 
    S = 0;
    for (i=1;i<=k;i++)  S += X[i];
    // ---------------------------- 
    if  (k<n+1 && S==B && m==k)
    {
      //     .
      for (i=1;i<=k;i++) cout << X[i] << " ";
      cout << endl;
    }
    else  
      if  (r->Id->Flag)
      {
         X[k] = r->Id->Key;
         r->Id->Flag = FALSE;
         Summa (k+1,B,n);
         r->Id->Flag = TRUE;
      }
    r = r->Next;
  }
}
